TCPStartup() ;TCP Dienst starten

$sIP = @IPAddress1
$iPort = 807

Global $hSocket = TCPListen($sIP, $iPort) ;TCP-Socket erstellen
Global $sRecv = "" ;Variabel fr die Empfangenen Daten
Global $iAccept = 0

$sFormatString = "Server erfolgreich Erstellt\n\n IP-Adresse: %s\nPort: %i"
MsgBox(64, "TCP-Server Programm", StringFormat($sFormatString, $sIP, $iPort)) ;Infos ber den Server anzeigen

While 1
	$iAccept = _TCP_Accept($hSocket) ;Mgliche Verbindungen zulassen
	While 1
		$sRecv = _TCP_Recv($iAccept) ;Daten empfangen
		If $sRecv = "CloseServer" Then _End() ;Server Beenden
		If $sRecv = "CloseCon" Then ExitLoop ;Verbindung zum Clienten schliessen
		If $sRecv <> "" Then
			$sFormatString = "Daten empfangen\nVon IP: %s\n\n%s"
			MsgBox(64, "Daten empfangen", StringFormat($sFormatString, _TCP_SocketToIP($iAccept), $sRecv)) ;Text anzeigen
		EndIf
	WEnd
WEnd

Func _TCP_Accept($iFunc_Socket = 0) ;Verbidungs-Funktion
	Local $iReturn
	Do
		$iReturn = TCPAccept($iFunc_Socket)
	Until $iReturn <> -1
	Return $iReturn
EndFunc   ;==>_TCP_Accept

Func _TCP_Recv($iFunc_Socket = 0) ;Funktion zum Gebufferten Empfangen
	Local $sReturn
	While 1
		$sReturn &= TCPRecv($iFunc_Socket, 10)
		If @error Then ExitLoop
	WEnd
	Return $sReturn
EndFunc   ;==>_TCP_Recv

Func _TCP_SocketToIP($SHOCKET) ;Socket -> IP Funktion
	Local $sockaddr, $aRet
	$sockaddr = DllStructCreate("short;ushort;uint;char[8]")
	$aRet = DllCall("Ws2_32.dll", "int", "getpeername", "int", $SHOCKET, _
			"ptr", DllStructGetPtr($sockaddr), "int*", DllStructGetSize($sockaddr))
	If Not @error And $aRet[0] = 0 Then
		$aRet = DllCall("Ws2_32.dll", "str", "inet_ntoa", "int", DllStructGetData($sockaddr, 3))
		If Not @error Then $aRet = $aRet[0]
	Else
		$aRet = 0
	EndIf
	$sockaddr = 0
	Return $aRet
EndFunc   ;==>_TCP_SocketToIP

Func _End() ;Beenden-Funktion
	TCPCloseSocket($iAccept)
	TCPCloseSocket($hSocket)
	TCPShutdown()
	Exit
EndFunc   ;==>_End